/**************************************************************************

   Lunar Compress C Dynamic DLL Access Program
   Created by FuSoYa, Defender of Relm (fusoya@moon.co.jp)
   http://fusoya.cg-games.net  (was http://fusoya.cjb.net)

   Check "LunarDLL.h" for documentation on using this file.

**************************************************************************/

//#include "stdafx.h"  //use this if you get errors compiling under VC
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "LunarDLL.h"

LCPROC1 LunarVersion;
LCPROC2 LunarCloseFile;
LCPROC3 LunarOpenFile;
LCPROC4 LunarGetFileSize;
LCPROC5 LunarReadFile;
LCPROC6 LunarWriteFile;
LCPROC7 LunarSNEStoPC;
LCPROC8 LunarPCtoSNES;
LCPROC9 LunarDecompress;
LCPROC10 LunarRecompress;
LCPROC11 LunarEraseArea;
LCPROC12 LunarExpandROM;
LCPROC13 LunarVerifyFreeSpace;
LCPROC14 LunarCreatePixelMap;
LCPROC15 LunarCreateBppMap;
LCPROC16 LunarSNEStoPCRGB;
LCPROC17 LunarPCtoSNESRGB;
LCPROC18 LunarRender8x8;
LCPROC19 LunarWriteRatArea;
LCPROC20 LunarEraseRatArea;
LCPROC21 LunarGetRatAreaSize;
LCPROC22 LunarOpenRAMFile;
LCPROC23 LunarSaveRAMFile;
LCPROC24 LunarIPSCreate;
LCPROC25 LunarIPSApply;
LCPROC26 LunarSetFreeBytes;

HINSTANCE LunarLibInst=NULL;


void LunarUnloadDLL()  {

   if (!LunarLibInst)
      return;	//the library is already unloaded
   FreeLibrary(LunarLibInst);
   LunarLibInst=NULL;
   return;   //library unloaded
}

int LunarLoadDLL()  {
unsigned int i=0;

   if (LunarLibInst)
      return 1;	//the library is already loaded
   LunarLibInst = LoadLibrary("Lunar Compress");
   if (!LunarLibInst) //hmm, try the other file name?
      LunarLibInst = LoadLibrary("Lunar_Compress");
   if (!LunarLibInst)
      return 0;	//Couldn't load DLL...

   // If the handle is valid, try to get the function addresses.
   i+=(unsigned int)( LunarVersion = (LCPROC1)GetProcAddress(LunarLibInst,"LunarVersion") );
   i+=(unsigned int)( LunarCloseFile = (LCPROC2)GetProcAddress(LunarLibInst,"LunarCloseFile") );
   i+=(unsigned int)( LunarOpenFile = (LCPROC3)GetProcAddress(LunarLibInst,"LunarOpenFile") );
   i+=(unsigned int)( LunarGetFileSize = (LCPROC4)GetProcAddress(LunarLibInst,"LunarGetFileSize") );
   i+=(unsigned int)( LunarReadFile = (LCPROC5)GetProcAddress(LunarLibInst,"LunarReadFile") );
   i+=(unsigned int)( LunarWriteFile = (LCPROC6)GetProcAddress(LunarLibInst,"LunarWriteFile") );
   i+=(unsigned int)( LunarSNEStoPC = (LCPROC7)GetProcAddress(LunarLibInst,"LunarSNEStoPC") );
   i+=(unsigned int)( LunarPCtoSNES = (LCPROC8)GetProcAddress(LunarLibInst,"LunarPCtoSNES") );
   i+=(unsigned int)( LunarDecompress = (LCPROC9)GetProcAddress(LunarLibInst,"LunarDecompress") );
   i+=(unsigned int)( LunarRecompress = (LCPROC10)GetProcAddress(LunarLibInst,"LunarRecompress") );
   i+=(unsigned int)( LunarEraseArea = (LCPROC11)GetProcAddress(LunarLibInst,"LunarEraseArea") );
   i+=(unsigned int)( LunarExpandROM = (LCPROC12)GetProcAddress(LunarLibInst,"LunarExpandROM") );
   i+=(unsigned int)( LunarVerifyFreeSpace = (LCPROC13)GetProcAddress(LunarLibInst,"LunarVerifyFreeSpace") );
   i+=(unsigned int)( LunarCreatePixelMap = (LCPROC14)GetProcAddress(LunarLibInst,"LunarCreatePixelMap") );
   i+=(unsigned int)( LunarCreateBppMap = (LCPROC15)GetProcAddress(LunarLibInst,"LunarCreateBppMap") );
   i+=(unsigned int)( LunarSNEStoPCRGB = (LCPROC16)GetProcAddress(LunarLibInst,"LunarSNEStoPCRGB") );
   i+=(unsigned int)( LunarPCtoSNESRGB = (LCPROC17)GetProcAddress(LunarLibInst,"LunarPCtoSNESRGB") );
   i+=(unsigned int)( LunarRender8x8 = (LCPROC18)GetProcAddress(LunarLibInst,"LunarRender8x8") );
   i+=(unsigned int)( LunarWriteRatArea = (LCPROC19)GetProcAddress(LunarLibInst,"LunarWriteRatArea") );
   i+=(unsigned int)( LunarEraseRatArea = (LCPROC20)GetProcAddress(LunarLibInst,"LunarEraseRatArea") );
   i+=(unsigned int)( LunarGetRatAreaSize = (LCPROC21)GetProcAddress(LunarLibInst,"LunarGetRatAreaSize") );
   i+=(unsigned int)( LunarOpenRAMFile = (LCPROC22)GetProcAddress(LunarLibInst,"LunarOpenRAMFile") );
	i+=(unsigned int)( LunarSaveRAMFile = (LCPROC23)GetProcAddress(LunarLibInst,"LunarSaveRAMFile") );
   i+=(unsigned int)( LunarIPSCreate = (LCPROC24)GetProcAddress(LunarLibInst,"LunarIPSCreate") );
	i+=(unsigned int)( LunarIPSApply = (LCPROC25)GetProcAddress(LunarLibInst,"LunarIPSApply") );
   i+=(unsigned int)( LunarSetFreeBytes = (LCPROC26)GetProcAddress(LunarLibInst,"LunarSetFreeBytes") );

   if (i>=26)
       return 1;	//load successful!

   LunarUnloadDLL();
   return 0;	//we couldn't find all the functions...
}



